<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'order';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 会员模块
include_once (ROOT_PATH . 'include/user.class.php');
$dou_user = new DouUser();

// 载入并实例化类库
require (ROOT_PATH . 'include/order.class.php');
$dou_order = new Order();

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 订单列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['order']);

    // 订单超过时间未付款，将自动取消，并释放库存
    $dou_order->auto_cancel_order();
 
    // 更新订单可申请售后状态，检测可申请售后状态为1的订单，需要保证超过售后期限后将其标注为0
    $dou_order->auto_update_aftersale_status();
 
    // 更新订单可评论状态，检测可评论状态为1的订单，需要保证超过评论期限后将其标注为0
    $dou_order->auto_update_comment();

    // 初始化
    $page_url = 'order.php';
 
    // 用户名
    $username = $check->is_username($_REQUEST['username']) ? $_REQUEST['username'] : '';
    if ($username) {
        $user_id = $dou->search_user_id($username);
        $where = " AND user_id = '$user_id'";
        $page_url = $page_url . "&username=$username";
    }

    // 筛选.类型
    $order_sn = $check->is_number($_REQUEST['order_sn']) ? $_REQUEST['order_sn'] : '';
    if ($order_sn) {
        $where = $where . " AND order_sn LIKE '%$order_sn%'";
        $page_url = $page_url . "&order_sn=$order_sn";
    }

    // 筛选.类型
    $order_consignee = $check->is_username($_REQUEST['order_consignee']) ? $_REQUEST['order_consignee'] : '';
    if ($order_consignee) {
        $where = $where . " AND (phone = '$order_consignee' OR contact = '$order_consignee' OR address = '$order_consignee')";
        $page_url = $page_url . "&order_consignee=$order_consignee";
    }
 
    // 筛选.时间
    $time_end = isset($_REQUEST['time_end']) ? trim($_REQUEST['time_end']) : '';
    $time_start = isset($_REQUEST['time_start']) ? trim($_REQUEST['time_start']) : '';
    if ($time_start) {
        $where = $where . " AND add_time > '" . strtotime($time_start) . "'";
        $page_url = $page_url . "&time_start=$time_start";
    }
    if ($time_end) {
        $where = $where . " AND add_time < '" . strtotime($time_end) . "'";
        $page_url = $page_url . "&time_end=$time_end";
    }
 
    // 格式化
    $where = $_SESSION['where'] = $dou->where($where);
    $page_url = $dou->param($page_url);
 
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('order') . $where . " ORDER BY order_id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 15, $page, $page_url);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $email = $dou->get_one("SELECT email FROM " . $dou->table('user') . " WHERE user_id = '$row[user_id]'");
        $add_time = date("Y-m-d H:i:s", $row['add_time']);
        $status_format = $_LANG['order_status_' . $row['status']];
        $order_amount = $dou->price_format($row['order_amount']);
        
        $order_list[] = array (
                "order_id" => $row['order_id'],
                "order_sn" => $row['order_sn'],
                "email" => $email,
                "mode" => $row['mode'],
                "phone" => $row['phone'],
                "contact" => $row['contact'],
                "order_amount" => $order_amount,
                "order_point" => $row['order_point'] . $_LANG['order_point_unit'],
                "status" => $row['status'],
                "status_format" => $row['aftersale_status'] == 2 ? $_LANG['order_aftersale_status_2'] : $status_format,
                "add_time" => $add_time
        );
    }
    
    // 赋值给模板
    $smarty->assign('req', $_REQUEST);
    $smarty->assign('order_list', $order_list);
    
    $smarty->display('order.htm');
} 

/**
 * +----------------------------------------------------------
 * 订单详情
 * +----------------------------------------------------------
 */
elseif ($rec == 'view') {
    $smarty->assign('ur_here', $_LANG['order_view']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['order_list'],
            'href' => 'order.php' 
    ));
    
    // 验证并获取合法的ID
    if ($order_sn = $check->is_number($_REQUEST['order_sn'])) {
        $order_id = $dou->get_one("SELECT order_id FROM " . $dou->table('order') . " WHERE order_sn = '$order_sn'");
    } else {
        $order_id = $check->is_number($_REQUEST['order_id']) ? $_REQUEST['order_id'] : '';
    }

    // 获取配送方式
    $shipping = $dou->get_plugin('shipping');
    
    $order = $dou->get_row('order', '*', "order_id = '$order_id'");
 
    $order['pay_name'] = $dou->get_one("SELECT name FROM " . $dou->table('plugin') . " WHERE unique_id = '$order[pay_id]'");
    $order['shipping_name'] = $dou->get_one("SELECT name FROM " . $dou->table('plugin') . " WHERE unique_id = '$order[shipping_id]'");
    $order['item_amount_format'] = $dou->price_format($order['item_amount']);
    $order['shipping_fee_format'] = $dou->price_format($order['shipping_fee']);
    $order['order_amount_format'] = $dou->price_format($order['order_amount']);
    $order['pay_evidence'] = $order['pay_evidence'] ? $dou->dou_file($order['pay_evidence']) : '';
 
    // 优惠券模块
    if ($_OPEN['coupon']) {
        include_once (ROOT_PATH . 'include/coupon.class.php');
        $dou_coupon = new Coupon();
     
        $order['coupon'] = $dou_coupon->get_coupon($order['coupon_id']);
        $order['coupon']['amount_format'] = $dou->price_format($order['coupon_amount']);
    }
 
    // 离线付款确认
    if ($order['pay_id'] == 'offlinepay' && $order['status'] == '-2')
        $order['need_pay_check'] = true;

    /* 获取产品列表 */
    $query = $dou->query("SELECT * FROM " . $dou->table('order_item') . " WHERE order_id = '$order_id' ORDER BY id DESC");

    while ($row = $dou->fetch_array($query)) {
        // 格式化价格
        $price = $dou->price_format($row['price']);
        
        $item_list[] = array (
                "item_id" => $row['item_id'],
                "name" => $row['name'],
                "item_number" => $row['item_number'],
                "url" => $dou->rewrite_url($row['module'], $row['item_id']),
                "price" => $price,
                "point" => $row['point'],
                "defined" => $defined
        );
    }
    
    // 格式化订单信息
    $order['email'] = $dou->get_one("SELECT email FROM " . $dou->table('user') . " WHERE user_id = '$order[user_id]'");
    $order['add_time'] = date("Y-m-d H:i:s", $order['add_time']);
    $order['status_format'] = $order['aftersale_status'] == 2 ? $_LANG['order_aftersale_status_2'] : $_LANG['order_status_' . $order['status']];
    $order['item_list'] = $dou_order->get_order_item($order['order_id']);;
    
    // 赋值给模板
    $smarty->assign('order', $order);
    $smarty->assign('shipping_list', $dou_order->get_shipping_list());
    
    $smarty->display('order.htm');
} 

/**
 * +----------------------------------------------------------
 * 销量统计
 * +----------------------------------------------------------
 */
elseif ($rec == 'data') {
    // 获取时间节点
    $today = date('Y-m-d');
    $yesterday = date('Y-m-d', strtotime('-1 day'));
    
    $sql = "SELECT * FROM " . $dou->table('product_category') . " ORDER BY sort ASC, cat_id DESC";
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $data['today']['category'][] = array (
                "cat_id" => $row['cat_id'],
                "cat_name" => $row['cat_name'],
                "count" => $dou->zero($dou->get_one("SELECT SUM(price) FROM " . $dou->table('order_item') . " WHERE cat_id = '$row[cat_id]' AND (order_status = '1' OR order_status = '10') AND DATE(from_UNIXTIME(add_time)) = '$today'"))
        );
        
        $data['yesterday']['category'][] = array (
                "cat_id" => $row['cat_id'],
                "cat_name" => $row['cat_name'],
                "count" => $dou->zero($dou->get_one("SELECT SUM(price) FROM " . $dou->table('order_item') . " WHERE cat_id = '$row[cat_id]' AND (order_status = '1' OR order_status = '10') AND DATE(from_UNIXTIME(add_time)) = '$yesterday'"))
        );
        
        $data['total']['category'][] = array (
                "cat_id" => $row['cat_id'],
                "cat_name" => $row['cat_name'],
                "count" => $dou->zero($dou->get_one("SELECT SUM(price) FROM " . $dou->table('order_item') . " WHERE cat_id = '$row[cat_id]' AND (order_status = '1' OR order_status = '10')"))
        );
    }
    
    // 总数据
    $data['today']['all'] = $dou->zero($dou->get_one("SELECT SUM(item_amount) FROM " . $dou->table('order') . " WHERE (status = '1' OR status = '10') AND DATE(from_UNIXTIME(add_time)) = '$today'"));

    $data['yesterday']['all'] = $dou->zero($dou->get_one("SELECT SUM(item_amount) FROM " . $dou->table('order') . " WHERE (status = '1' OR status = '10') AND DATE(from_UNIXTIME(add_time)) = '$yesterday'"));

    $data['total']['all'] = $dou->zero($dou->get_one("SELECT SUM(item_amount) FROM " . $dou->table('order') . " WHERE (status = '1' OR status = '10')"));
 
    // 赋值给模板
    $smarty->assign('data', $data);
    
    $smarty->display('order.htm');
}

/**
 * +----------------------------------------------------------
 * 确认收款
 * +----------------------------------------------------------
 */
elseif ($rec == 'pay_check') {
    // 验证并获取合法的ID
    $order_id = $check->is_number($_REQUEST['order_id']) ? $_REQUEST['order_id'] : exit;
    $order_sn = $dou->get_one("SELECT order_sn FROM " . $dou->table('order') . " WHERE order_id = '$order_id'");
    
    $dou_order->change_status($order_sn, 1);
    
    $dou->dou_header('order.php?rec=view&order_id=' . $order_id);
} 

/**
 * +----------------------------------------------------------
 * 快递单号填写
 * +----------------------------------------------------------
 */
elseif ($rec == 'tracking') {
    // 验证并获取合法的ID
    $order_id = $check->is_number($_REQUEST['order_id']) ? $_REQUEST['order_id'] : exit;
    
    $order = $dou->get_row('order', '*', "order_id = '$order_id'");
    $shipping_time = time();
    
    // 插入订单号并在订单状态设定为已发货
    if ($order['tracking_no']) { // 已经发货的，修改单号不要重复执行订单操作
        $dou->query("UPDATE " . $dou->table('order') . " SET shipping_id = '$_POST[shipping_id]', tracking_no = '$_POST[tracking_no]', shipping_time = '$shipping_time' WHERE order_id = '$order_id'");
    } else {
        $dou_order->change_status($order['order_sn'], 10);
        $dou->query("UPDATE " . $dou->table('order') . " SET shipping_id = '$_POST[shipping_id]', tracking_no = '$_POST[tracking_no]', shipping_time = '$shipping_time', allow_aftersale = '1' WHERE order_id = '$order_id'");
     
        // 商品下单付款后会锁定库存，付款后解锁，考虑未开通支付方式的情况，发货时再操作一次库存解锁（stock_lock = 0）
        $dou->query("UPDATE " . $dou->table('order_item') . " SET stock_lock = '0' WHERE order_id = '$order_id'");
    }
    
    $dou->dou_header('order.php?rec=view&order_id=' . $order_id);
}

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'del_all') {
            // 批量订单删除
            foreach ((array) $_POST['checkbox'] as $order_id) {
                $order = $dou->get_row('order', '*', "order_id = '$order_id'");
                
                $dou->delete('order', "order_id = '$order_id'");
                $dou->delete('order_item', "order_id = '$order_id'");
                
                // 如果存在状态关联信息也要删除
                if ($order['item_link_status'])
                    $dou->delete($order['module'], "order_sn = '$order[order_sn]'");
            }
         
            $GLOBALS['dou']->dou_msg($GLOBALS['_LANG']['order_del_success'], 'order.php?page=' . $_SESSION[DOU_ID]['page']);
        } elseif ($_POST['action'] == 'cancel_all') {
            // 订单批量删除
            $dou_order->cancel_all($_POST['checkbox']);
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        $dou->dou_msg($_LANG['order_select_empty']);
    }
} 

/**
 * +----------------------------------------------------------
 * 参数设置
 * +----------------------------------------------------------
 */
elseif ($rec == 'set') {
    $set_list = array('order_pay_timeout', 'order_allow_aftersale_time', 'order_allow_comment_time');
    foreach ($set_list as $name) {
        if (!$dou->value_exist('parameter', 'name', $name)) {
            $dou->query("INSERT INTO " . $dou->table('parameter') . " (id, name, lang, value, cue, `group`)" . " VALUES (NULL, '$name', '" . $_LANG['order_' . $name . '_lang'] . "', '" . $_LANG['order_' . $name . '_value'] . "', '" . $_LANG['order_' . $name . '_cue'] . "', 'order')");
        }
    }
    $dou->dou_header('parameter.php?rec=set&group=order');
}

?>