-- DouPHP 模块数据导入
-- ------------------------------------------------------------------------------------------


DROP TABLE IF EXISTS `dou_order`;
CREATE TABLE `dou_order` (
  `order_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `order_sn` varchar(20) NOT NULL DEFAULT '',
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `direct_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `indirect_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `mode` varchar(20) NOT NULL DEFAULT 'money',
  `module` varchar(20) NOT NULL DEFAULT '',
  `cat_id` smallint(5) NOT NULL DEFAULT '0',
  `phone` varchar(20) NOT NULL DEFAULT '',
  `contact_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `contact` varchar(60) NOT NULL DEFAULT '',
  `email` varchar(180) NOT NULL DEFAULT '',
  `address` varchar(255) NOT NULL DEFAULT '',
  `postcode` varchar(60) NOT NULL DEFAULT '',
  `pay_id` varchar(30) NOT NULL DEFAULT '',
  `pay_evidence` varchar(255) NOT NULL DEFAULT '',
  `shipping_id` varchar(30) NOT NULL DEFAULT '',
  `tracking_no` varchar(255) NOT NULL DEFAULT '',
  `shipping_fee` decimal(10,2) NOT NULL DEFAULT '0.00',
  `coupon_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `coupon_amount` decimal(10,2) unsigned NOT NULL DEFAULT '0.00',
  `item_amount` decimal(10,2) unsigned NOT NULL DEFAULT '0.00',
  `order_amount` decimal(10,2) NOT NULL DEFAULT '0.00',
  `order_point` smallint(8) unsigned NOT NULL DEFAULT '0',
  `direct_reward` decimal(10,2) unsigned NOT NULL DEFAULT '0.00',
  `indirect_reward` decimal(10,2) unsigned NOT NULL DEFAULT '0.00',
  `pay_time` int(11) unsigned NOT NULL DEFAULT '0',
  `shipping_time` int(11) unsigned NOT NULL DEFAULT '0',
  `allow_aftersale` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `aftersale_status` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `allow_comment` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `item_link_status` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '0',
  `add_time` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`order_id`),
  UNIQUE KEY `order_sn` (`order_sn`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `dou_order_item`;
CREATE TABLE `dou_order_item` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `direct_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `indirect_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `order_id` int(10) unsigned NOT NULL DEFAULT '0',
  `module` varchar(20) NOT NULL,
  `cat_id` smallint(5) NOT NULL DEFAULT '0',
  `work_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `item_id` smallint(8) unsigned NOT NULL DEFAULT '0',
  `name` varchar(150) NOT NULL DEFAULT '',
  `price` decimal(10,2) unsigned NOT NULL DEFAULT '0.00',
  `sale_price` decimal(10,2) unsigned NOT NULL DEFAULT '0.00',
  `sale_price_type` varchar(60) NOT NULL DEFAULT 'original',
  `point` smallint(8) unsigned NOT NULL DEFAULT '0',
  `direct_reward` decimal(10,2) unsigned NOT NULL DEFAULT '0.00',
  `indirect_reward` decimal(10,2) unsigned NOT NULL DEFAULT '0.00',
  `item_number` smallint(5) unsigned NOT NULL DEFAULT '1',
  `attribute` varchar(120) NOT NULL DEFAULT '',
  `attribute_name` varchar(120) NOT NULL DEFAULT '',
  `stock_lock` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `aftersale` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `comment` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `defined` text,
  `order_status` tinyint(1) NOT NULL DEFAULT '0',
  `add_time` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `dou_order_cart`;
CREATE TABLE `dou_order_cart` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `module` varchar(20) NOT NULL,
  `item_id` smallint(8) unsigned NOT NULL DEFAULT '0',
  `item_number` smallint(5) unsigned NOT NULL DEFAULT '1',
  `attribute` varchar(120) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


