// index.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  /**
   * 页面的初始数据
   */
  data: {
    payment: 'wxpay'
  },
  
  onShow: function(options) {
    // 判断是否登录
    dou.checkLoginState('page', '/pages/order/order')
  },
 
  onLoad: function(options) {
    var that = this
    
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site,
          open: res.data.open
        })
      },
    })
    
    wx.request({
      url: app.mp_url + 'order.php?rec=cashier',
      data: {
        'user_id': wx.getStorageSync('user_id'),
        'shell': wx.getStorageSync('shell'),
        'order_sn': options.order_sn
      },
      method:'POST',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key'),
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      success: function(res) {
        console.log(res.data)
        that.setData({
          title: res.data.title
        })

        that.setData({
          order: res.data.order
        })
      },
    })
  },
 
  // 选择付款方式
  selectPayment: function() {
    var that = this;
    
    if (that.data.payment == 'wxpay') {
      that.setData ({
        payment: 'offlinepay'
      })
    } else {
      that.setData ({
        payment: 'wxpay'
      })
    }
  },
 
  wxpay: function (e) {
    var that = this
    
    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/user/user')
    
    wx.request({
      url: app.mp_url + 'user.php?rec=wxpay',//改成你自己的链接
      data:{
        'user_id': wx.getStorageSync('user_id'),
        'shell': wx.getStorageSync('shell'),
        'order_sn': e.currentTarget.dataset.order_sn
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key'),
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      method: 'POST',
      success: function (res) {
        console.log('调起支付');
        if (res.data.wrong) {
          dou.douMsg(res.data.wrong)
        } else {
          wx.requestPayment({
            'timeStamp': res.data.timeStamp,
            'nonceStr': res.data.nonceStr,
            'package': res.data.package,
            'signType': 'MD5',
            'paySign': res.data.paySign,
            'success': function (res) {
              console.log('success');
              dou.douMsg('支付成功', '/pages/user/order_list')
            },
            'fail': function (res) {
              //console.log(res);
            },
            'complete': function (res) {
              console.log('支付完成');
            }
          })
        }
      }
    });
  },
 
  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  },

  // 只能跳转到tabBar配置页面
  douSwitchTab: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.switchTab({
      url: url
    })
  }


})