// index.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
      contact:'',
      contact_list:[],
      isVisible: false, // 初始状态为显示
  },
 
  onShow: function(options) {
    // 判断是否登录
    dou.checkLoginState('page', '/pages/order/order')
    
    this.contactList()
  },
 
  onLoad: function(options) {
    var that = this
    
    that.setData({
      mode: wx.getStorageSync('product_buy_mode')
    })
    
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
    
    wx.request({
      url: app.mp_url + 'order.php?rec=checkout',
      data: {
        'user_id': wx.getStorageSync('user_id'),
        'shell': wx.getStorageSync('shell'),
        'mode': wx.getStorageSync('product_buy_mode')
      },
      method:'POST',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key'),
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      success: function(res) {
        that.setData({
          title: res.data.title
        })
        
        if (res.data.cart.module == 'vip_package')
          that.orderSuccess()
        
        that.setData({
          cart: res.data.cart,
          shipping_list: res.data.shipping_list,
          shipping_id: res.data.shipping_id,
          coupon_list: res.data.coupon_list,
          coupon_id: res.data.coupon_id,
          order: res.data.order,
          amount: res.data.amount,
          mode: wx.getStorageSync('product_buy_mode')
        })
      },
    })
    
    if (options.contact_id) {
      that.setData({
        contact_id: options.contact_id
      })
    }
    
    that.contactSelect()
  },
 
  orderSuccess: function(e) {
    var that = this

    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/order/order')
    var form = e ? e.detail.value : ''
    
    wx.request({
      url: app.mp_url + 'order.php?rec=checkout_post',
      data: {
        'user_id': wx.getStorageSync('user_id'),
        'shell': wx.getStorageSync('shell'),
        'contact_id': that.data.contact_id || 0,
        'contact': form ? form.contact : '',
        'address': form ? form.address : '',
        'phone': form ? form.phone : '',
        'postcode': form ? form.postcode : '',
        'action': form ? form.action : '',
        'update_user_information': form ? form.update_user_information : '',
        'shipping_id': form ? form.shipping_id : 0,
        'coupon_id': form ? form.coupon_id : 0,
        'mode': wx.getStorageSync('product_buy_mode')
      },
      method:'POST',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key'),
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      success: function(res) {
        if (res.data.wrong) {
          dou.douMsg(res.data.wrong)
        } else {
          wx.redirectTo({
            url: res.data.cashier_url
          })
        }
      },
    })
  },
 
  radioShipping: function(e) {
    var that = this

    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/order/order')
    
    wx.request({
      url: app.mp_url + 'order.php?rec=change_shipping',
      data: {
        'user_id': wx.getStorageSync('user_id'),
        'shell': wx.getStorageSync('shell'),
        'shipping_id': e.detail.value,
        'coupon_amount': that.data.amount.coupon_amount
      },
      method:'POST',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key'),
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      success: function(res) {
        that.setData({
          amount: res.data.amount,
          shipping_id: e.detail.value
        })
      },
    })
  },
 
  useCoupon: function(e) {
    var that = this

    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/order/order')
    
    wx.request({
      url: app.mp_url + 'order.php?rec=use_coupon',
      data: {
        'user_id': wx.getStorageSync('user_id'),
        'shell': wx.getStorageSync('shell'),
        'coupon_id': e.detail.value,
        'shipping_fee': that.data.amount.shipping_fee
      },
      method:'POST',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key'),
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      success: function(res) {
        that.setData({
          amount: res.data.amount,
          coupon_id: e.detail.value
        })
      },
    })
  },
        
  // 联系人列表
  contactList:function() {
    var that = this;

    wx.request({
      url: app.mp_url + 'user.php?rec=contact&act=list',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        contact_id: that.data.contact_id
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.setData({
          contact_list: res.data.contact_list
        })
      }
    })
  },

  // 选择联系人
  contactSelect:function(e) {
    var that = this;
   
    var contact_id = e ? e.currentTarget.dataset.contact_id : '';
    if (!contact_id) {
      var contact_id = that.data.contact_id || ''
    }
    
    wx.request({
      url: app.mp_url + 'user.php?rec=contact&act=info',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        contact_id: contact_id
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        if (res.data.contact) {
          that.setData({
            contact: res.data.contact,
            contact_id: res.data.contact.id
          })
          that.contactList();
          if (contact_id) {
            that.setData({
              isVisible: false
            })
          }
        }
      }
    })
  },
        
  // 联系人列表弹出
  contactPopup:function() {
    this.setData({
      isVisible: !this.data.isVisible // 切换状态
    })
  },
 
  contactInfo: function(e) {
    var that = this

    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/order/order')
    
    wx.request({
      url: app.mp_url + 'user.php?rec=contact&act=info',
      data: {
        'user_id': wx.getStorageSync('user_id'),
        'shell': wx.getStorageSync('shell')
      },
      method:'POST',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key'),
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      success: function(res) {
        console.log(res.data)
        that.setData({
          contact: res.data.contact
        })
      },
    })
  },
 
  updateInfo: function(e) {
    this.setData({
      update_user_information: e.detail.value
    })
  },
 
  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  },
 
  // 可以带参数
  douRedirectTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.redirectTo({
      url: url
    })
  },

  // 只能跳转到tabBar配置页面
  douSwitchTab: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.switchTab({
      url: url
    })
  },


})