// index.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
    payEvidenceTemp: '' //初始化为空
  },
 
  onShow: function(options) {
    // 判断是否登录
    dou.checkLoginState()
  },
 
  onLoad: function(options) {
    var that = this
    
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
   
    that.loadData(options.order_sn)
  },
 
  loadData: function(order_sn = 0) {
    var that = this
    
    wx.request({
      url: app.mp_url + 'order.php?rec=pay',
      data: {
        'user_id': wx.getStorageSync('user_id'),
        'shell': wx.getStorageSync('shell'),
        'order_sn': order_sn
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.setData({
          title: res.data.title
        })
        
        that.setData({
          order: res.data.order
        })
      },
    })
  },
 
  // 上传付款凭证
  payEvidence: function(e) {
    var that = this;
    
    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/user/user')
   
    wx.chooseImage({ //从本地相册选择图片或使用相机拍照
      count: 1, // 默认9
      sizeType: ['original', 'compressed'], // 可以指定是原图还是压缩图，默认二者都有
      sourceType: ['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有
      success: function(res) {
        //console.log(res)
        //前台显示
        that.setData({
          payEvidenceTemp: res.tempFilePaths
        })

        // 返回选定照片的本地文件路径列表，tempFilePath可以作为img标签的src属性显示图片
        var tempFilePaths = res.tempFilePaths;
        
        wx.uploadFile({
          url: app.mp_url + 'order.php?rec=pay_evidence',
          filePath: tempFilePaths[0],
          formData: {
            'user_id': wx.getStorageSync('user_id'),
            'shell': wx.getStorageSync('shell'),
            'order_sn': e.currentTarget.dataset.order_sn
          },
          header: {
            'Connect-Key' : wx.getStorageSync('connect_key'),
            'Content-Type': 'application/x-www-form-urlencoded'
          },
          name: 'pay_evidence',
          success: function(info) {
            var data = JSON.parse(info.data)
            //打印
            console.log(data.wrong)
            if (data.wrong) {
              dou.douMsg(data.wrong)
            } else {
              dou.douMsg('上传成功')
              wx.reLaunch({
                url: '/pages/user/order_list'
              })
            }
          }
        })
      }
    })
  },
 
  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  },
 
  radioSex: function(e) {
    this.setData({
      sex: e.detail.value
    })
  }


})