// index.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
      startX: 0, // 开始X坐标
      startY: 0, // 开始Y坐标
  },

  onShow: function() {
    var that = this
   
    // 判断是否登录
    dou.checkLoginState()
   
    that.loadData()
  },
 
  onLoad: function(options) {
    var that = this
   
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
   
    wx.setStorageSync('product_buy_mode', 'money')
    
    that.loadData()
  },
 
  loadData: function() {
    var that = this

    wx.request({
      url: app.mp_url + 'order.php',
      data: {
        'user_id': wx.getStorageSync('user_id'),
        'shell': wx.getStorageSync('shell')
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.setData({
          title: res.data.title
        })
        
        that.setData({
          cart: res.data.cart
        })
      },
    })
  },

  changeNumber: function (e) {
    var that = this
    
    // 未登录时重新载入当前页面
    dou.checkLoginState('action')
    
    wx.request({
      url: app.mp_url + 'order.php?rec=update',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        'action': e.currentTarget.dataset.action,
        'id': e.currentTarget.dataset.id
      },
      method:'POST',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key'),
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      success: function (res) {
        if (res.data.wrong) {
          dou.douMsg(res.data.wrong)
        } else {
          that.loadData()
        }
      }
    })
  },
 
  // 手指触摸动作开始
  touchStart: function(e){
      var that = this;
   
      // 记录手指触摸开始坐标
      that.setData({
          startX: e.changedTouches[0].clientX,  // 开始X坐标
          startY: e.changedTouches[0].clientY,  // 开始Y坐标
      })
  },

  // 手指触摸后移动
  touchMove: function(e){
      var that = this;
      
      var index = e.currentTarget.dataset.index; // 当前下标
      var cart = that.data.cart;
   
      var startX = that.data.startX; // 开始X坐标
      var startY = that.data.startY; // 开始Y坐标
      var touchMoveX = e.changedTouches[0].clientX; // 滑动变化坐标
      var touchMoveY = e.changedTouches[0].clientY; // 滑动变化坐标
      var moveWidth = startX - touchMoveX;
      
      // 获取滑动角度
      var angle = that.angle({ X: startX, Y: startY }, { X: touchMoveX, Y: touchMoveY });
      
      if (Math.abs(angle) > 45) return;
   
      if (cart['list'][index].touch_move_start == 80) {
          if (moveWidth > 0) {
              return;
          } else {
              var touchMove = cart['list'][index].touch_move_start + moveWidth;
          }
      } else {
          if (moveWidth > 80)
              var moveWidth = 80;

          if (moveWidth < 0)
              var moveWidth = 0;
          
          var touchMove = moveWidth;
      }
   
      cart['list'][index].touch_move = touchMove;
   
      that.setData({
        cart: cart
      })
  },

  // 手指触摸后停止
  touchEnd: function(e){
      var that = this;
      
      var index = e.currentTarget.dataset.index; // 当前下标
      var cart = that.data.cart;
      
      var startX = that.data.startX; // 开始X坐标
      var startY = that.data.startY; // 开始Y坐标
      var touchMoveX = e.changedTouches[0].clientX; // 滑动变化坐标
      var touchMoveY = e.changedTouches[0].clientY; // 滑动变化坐标
      var moveWidth = startX - touchMoveX; // 滑动距离
      
      // 获取滑动角度
      var angle = that.angle({ X: startX, Y: startY }, { X: touchMoveX, Y: touchMoveY });
    
      if (Math.abs(angle) > 45) return;
      
      if (moveWidth >= 0) {
          // 划入操作
          if (moveWidth > 20) {
              var moveWidth = 80;
          } else {
              var moveWidth = 0;
          }
      } else {
          if (moveWidth < -20) {
              var moveWidth = 0;
          } else {
              var moveWidth = 80;
          }
              
      }
   
      cart['list'][index].touch_move = moveWidth;
      cart['list'][index].touch_move_start = moveWidth;
   
      that.setData({
        cart: cart
      })
      
      //console.log(touchMoveX)
  },

  // 计算滑动角度
  angle: function (start, end) {
      let that = this,
          _X = end.X - start.X,
          _Y = end.Y - start.Y;
      
      // 返回角度 /Math.atan()返回数字的反正切值
      return 360 * Math.atan(_Y / _X) / (2 * Math.PI);
  },

  itemDel: function (e) {
    var that = this
    
    // 未登录时重新载入当前页面
    dou.checkLoginState('action')
    
    wx.request({
      url: app.mp_url + 'order.php?rec=del',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        'id': e.currentTarget.dataset.id
      },
      method:'POST',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key'),
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      success: function (res) {
        that.loadData()
      }
    })
  },
 
  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  }


})