<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'cart|insert|checkout|update|del|success|cashier|pay|pay_evidence|cod|contact_list|contact_select';
$subbox = array(
        "module" => 'order',
        "sub" => $sub
);

if (!defined('REWRITE')) {
    $_CUR = 'order';
    require (dirname(__FILE__) . '/include/init.php');
}
$smarty->assign('cur', $_CUR);
$smarty->assign('url', $_URL = $dou->dou_sub_url($subbox));

// 验证是否登录
if (!is_array($_GLOBAL_USER)) {
    $dou->dou_header($_URL['login']);
} else {
    $user_id = $_GLOBAL_USER['user_id'];
}

// 引入和实例化订单功能
include_once (ROOT_PATH . 'include/order.class.php');
$dou_order = new Order();

// 优惠券模块
if ($_OPEN['coupon']) {
    include_once (ROOT_PATH . 'include/coupon.class.php');
    $dou_coupon = new Coupon();
}

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'cart';

// 赋值给模板-meta和title信息
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle', 0, 'order', 0));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

// 赋值给模板-数据
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 购物车项目列表
 * +----------------------------------------------------------
 */
if ($rec == 'cart') {
    $cart = $dou_order->get_cart();
    
    // 只有商品模块才能一次购买多个
    if ($cart && $cart['module'] != 'product')
        $dou->dou_header($_URL['checkout']);
    
    // 赋值给模板-数据
    $smarty->assign('cart', $cart);
    $smarty->assign('page_title', $dou->page_title('order_cart'));
    $smarty->assign('head', $_LANG['order_cart']);

    $smarty->display('order.dwt');
}

/**
 * +----------------------------------------------------------
 * 项目加入购物车
 * +----------------------------------------------------------
 */
elseif ($rec == 'insert') {
    $module = $check->is_extend_id($_REQUEST['module']) ? $_REQUEST['module'] : 'product';
    $item_id = $check->is_number($_REQUEST['item_id']) ? $_REQUEST['item_id'] : '';
    $item_number = $check->is_number($_REQUEST['number']) ? $_REQUEST['number'] : 1;
    $mode = $check->is_letter($_REQUEST['mode']) ? $_REQUEST['mode'] : 'money';
    $action = $check->is_letter($_REQUEST['action']) ? $_REQUEST['action'] : 'addtocart';
    $user_id = $_GLOBAL_USER['user_id'];
    
    // 判断项目是否存在
    if (!$dou->value_exist($module, 'id', $item_id)) {
        if ($_POST['from'] == 'js') {
            $data['wrong'] = $_LANG['order_item_wrong'];
            die(json_encode($data));
        } else {
            $dou->dou_msg($_LANG['order_item_wrong'], $_URL['cart']);
        }
    }
    
    // 如果购物车中存在不同模块商品或为积分兑换，则先清空购物车
    if ($dou->value_exist('order_cart', 'user_id', $user_id, "module != '$module'") || $mode == 'point')
        $dou_order->clear_cart();
 
    // 如果不是商品模块或者是立即购买，要先清空购物车，一次只允许购买一件
    if ($module != 'product' || $action == 'buynow')
        $dou_order->clear_cart();
 
    // 项目信息
    $item = $dou->get_row($module, '*', "id = '$item_id'");
    $name = $item['name'] ? $item['name'] : $item['title'];
    $price = $item['price'];
    
    // 款式属性
    if ($_OPEN['attribute']) {
        include_once (ROOT_PATH . 'include/attribute.class.php');
        $dou_attribute = new douAttribute();
        $attribute_list = $dou_attribute->get_attribute_list($module, $item['cat_id'], $item['id']);
        
        foreach ($attribute_list as $item) {
            $attribute_array[] = $_REQUEST['att_' . $item['att_id']];
        }
        $attribute = implode('_', $attribute_array);
    }
    
    // 加入购物车
    $check_stock = $dou_order->check_stock($module, $item_id, $item_number);
    if ($check_stock['code'] == 'without_limit') { // 没有超出购买限制
        // 判断是否已经存在购物车中
        $cart_row = $dou->get_row('order_cart', 'id, item_number', "user_id = '$user_id' AND module = '$module' AND item_id = '$item_id' AND attribute = '$attribute'");
        
        if ($cart_row) { // 已经存在于购物车
            $item_number = $cart_row['item_number'] + $item_number; // 获取商品数量，如果存在于购物车中，则要加上
            $dou->query("UPDATE " . $dou->table('order_cart') . " SET item_number = '$item_number' WHERE id = '$cart_row[id]'");
        } else { // 新加入购物车
            $dou->query("INSERT INTO " . $dou->table('order_cart') . " (id, user_id, module, item_id, item_number, attribute)" . " VALUES (NULL, '$user_id', '$module', '$item_id', '$item_number', '$attribute')");
        }
     
        if ($_POST['from'] == 'js') {
            $data['jump_url'] = $_URL['cart'];
            die(json_encode($data));
        }
        
        if ($mode == 'point') {
            $dou->dou_header($dou->param($_URL['checkout'] . '&mode=point'));
        } else {
            if ($module == 'product') {
                if ($action == 'buynow') {
                    $dou->dou_header($_URL['checkout']);
                } else {
                    $dou->dou_header($_URL['cart']);
                }
            } elseif ($module == 'vip_package' || $module == 'money_package') {
                $dou->dou_header($dou->param($_URL['success'] . '&token=' . $_REQUEST['token']));
            } else {
                $dou->dou_header($_URL['checkout']);
            }
        }
    } else { // 超出购买限制，弹出提示
        $dou->dou_msg($check_stock['msg']);
    }
}

/**
 * +----------------------------------------------------------
 * 更新购物车商品数量
 * +----------------------------------------------------------
 */
elseif ($rec == 'update') {
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    $item_number = $check->is_number($_POST['number']) ? $_POST['number'] : 1;
    $user_id = $_GLOBAL_USER['user_id'];
 
    // 因为购物车里不能同时包含两种模块商品，所以直接抽取一条数据读取模块信息
    $module = $dou->get_one("SELECT module FROM " . $dou->table('order_cart') . " WHERE user_id = '$user_id'");
 
    // 如果不是商品模块，不允许更新商品数量
    if ($module != 'product')
        exit;
 
    // 获取购物车项目信息
    $order_cart = $dou->get_row('order_cart', '*', "id = '$id'");
 
    // 购买限制
    $check_stock = $dou_order->check_stock($module, $order_cart['item_id'], $item_number);
    if ($check_stock['code'] != 'without_limit')
        $item_number = $check_stock['real_time_stock'];
 
    // 更新商品数量
    $return = $dou->query("UPDATE " . $dou->table('order_cart') . " SET item_number = '$item_number' WHERE user_id = '$user_id' AND id = '$id'");

    // 获取购物车信息.再次获取更新后的
    $cart = $dou_order->get_cart();
 
    // 格式化数据
    $item_price = $dou->get_one("SELECT price FROM " . $dou->table($module) . " WHERE id = '$order_cart[item_id]'");
    $sale_price = $dou->sale_price($module, $order_cart['item_id'], $user_id); // 会员等级价格
    $item_price = $sale_price ? $sale_price['value'] : $item_price;
 
    // 款式属性
    if ($_OPEN['attribute'] && $order_cart['attribute']) {
        $attribute_list = explode('_', $order_cart['attribute']);
        foreach ($attribute_list as $value_id) {
            $attribute_value = $dou->get_row('attribute_value', '*', "id = '$value_id'");
         
            // 如果款式不是当前商品的，则清空购物车
            if ($attribute_value['item_id'] != $order_cart['item_id'])
                $dou_order->clear_cart();
            
            $item_price = $item_price + $attribute_value['price_change'];
        }
    }
 
    $subtotal = $item_price > 0 ? $dou->price_format($item_price * $item_number) : $_LANG['price_discuss'];
    
    $order = array (
            "subtotal" => $subtotal,
            "total" => $cart['total'],
            "item_number" => $item_number,
            "item_amount" => $dou->price_format($cart['item_amount'])
    );
    
    echo json_encode($order);
}

/**
 * +----------------------------------------------------------
 * 删除商品
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    $user_id = $_GLOBAL_USER['user_id'];
    
    // 删除对应商品
    $dou->query("DELETE FROM " . $dou->table('order_cart') . " WHERE id = '$id' AND user_id = '$user_id'");

    $dou->dou_header($_URL['cart']);
}

/**
 * +----------------------------------------------------------
 * 结算页面
 * +----------------------------------------------------------
 */
elseif ($rec == 'checkout') {
    // CSRF防御令牌生成
    $smarty->assign('token', $firewall->get_token('static_user'));
    
    // 获取默认配送方式信息
    $shipping = $dou->get_one("SELECT config FROM " . $dou->table('plugin') . " WHERE plugin_group = 'shipping'");
    $shipping = unserialize($shipping);
    
    // 获取购物车信息
    $cart = $dou_order->get_cart();
 
    // 检查购物车是否有商品
    if (!$cart)
        $dou->dou_msg($_LANG['order_cart_empty'], HOME_URL);
 
    // 免费额度
    if (($shipping['free'] && $cart['item_amount'] >= $shipping['free']) || $mode == 'point' || $cart['module'] != 'product')
        $shipping['fee'] = 0;
    
    // 运费和优惠券缓存
    $_SESSION[DOU_ID]['fee'] = $shipping['fee'];
    $_SESSION[DOU_ID]['coupon'] = 0.00;
 
    // 获取订单信息
    $order = $dou->get_row('user', 'contact, first_name, last_name, phone, country, province, address, postcode', "user_id = '" . $_GLOBAL_USER['user_id'] . "'");
    $order['shipping_fee_format'] = $dou->price_format($shipping['fee']);
    $order['coupon_amount_format'] = $dou->price_format('0.00');
    $order['order_amount_format'] = $dou->price_format($cart['item_amount'] + $shipping['fee']);
    $order['mode'] = $check->is_letter($_REQUEST['mode']) ? $_REQUEST['mode'] : 'money';
 
    // 优惠券模块
    if ($_OPEN['coupon'])
        $smarty->assign('coupon_list', $dou_coupon->get_user_coupon_list());
    
    // CSRF防御令牌生成
    $smarty->assign('token', $firewall->get_token('static_user'));
    
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('order_checkout'));
    $smarty->assign('head', $_LANG['order_checkout']);
    $smarty->assign('cart', $cart);
    $smarty->assign('shipping_list', $dou_order->get_shipping_list());
    $smarty->assign('order', $order);
    $smarty->display('order.dwt');
}

/**
 * +----------------------------------------------------------
 * 完成订单操作，提交到数据库
 * +----------------------------------------------------------
 */
elseif ($rec == 'success') {
    // 获取购物车信息
    $cart = $dou_order->get_cart();
 
    $mode = $check->is_letter($_REQUEST['mode']) ? $_REQUEST['mode'] : 'money';
    $contact_id = $check->is_number($_REQUEST['contact_id']) ? $_REQUEST['contact_id'] : '';
    
    // 商品模块才验证联系人信息
    if ($cart['module'] == 'product') {
        if (!$dou->value_exist('user_contact', 'id', $contact_id, "user_id = '$user_id'"))
            $wrong['contact_id'] = $_LANG['order_consignee_wrong'];
    }
 
    // AJAX验证表单
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }

    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format .= $wrong[$key] . '<br>';
        }
        $dou->dou_msg($wrong_format, $_URL['edit']);
    }

    // 验证是否登录
    if (!is_array($_GLOBAL_USER)) {
        $dou->dou_header($_URL['login']);
    }

    // CSRF防御令牌验证
    $firewall->check_token($_REQUEST['token'], 'static_user');
    
    // 检查购物车是否有商品
    if (!$cart)
        $dou->dou_msg($_LANG['order_cart_empty'], $_URL['cart']);
 
    // 获取和格式化数据
    $order_sn = $dou_order->create_order_sn();
    $module = $cart['module'];
    $order_point = $cart['order_point'];
    $add_time = time();
    $shipping_id = preg_match("/^[A-Za-z0-9_-]+$/", $_REQUEST['shipping_id']) ? $_REQUEST['shipping_id'] : '';
    $item_link_status = $module == 'vip_package' || $module == 'money_package' ? 1 : 0; // 关联订单，付款后可将VIP套餐购买记录标记为1
    $coupon_id = $check->is_number($_POST['coupon_id']) ? $_POST['coupon_id'] : 0;
 
    // 联系人信息
    $user_contact = $dou->get_row('user_contact', '*', "id = '$contact_id' AND user_id = '$user_id'");
    $contact = $user_contact['name'];
    $phone = $user_contact['telphone'];
    $address = $dou_user->address_full($user_contact);
    
    // 积分兑换
    if ($mode == 'point') {
        if (!$dou_user->create_point($_GLOBAL_USER['user_id'], 'exchange', $order_point*(-1), $order_sn)) {
            $dou_order->clear_cart();
            $dou->dou_msg($_LANG['point_not_enough'], $_URL['user']);
        }
    }
    
    // 购买限制
    foreach ($cart['list'] as $item) {
        $check_stock = $dou_order->check_stock($cart['module'], $item['item_id'], $item['number']);
        if ($check_stock['code'] != 'without_limit') {
            $dou->dou_msg($item['name'] . $check_stock['msg'], $_URL['cart']);
        }
    }
 
    // 订单总金额
    $item_amount = $cart['item_amount'];
 
    // 优惠券模块
    if ($_OPEN['coupon']) {
        $coupon = $dou_coupon->discount($coupon_id, $item_amount);
        if ($coupon) {
            $item_amount = $coupon['item_amount'];
            $coupon_amount = $coupon['amount'];
         
            // 标记优惠券为使用
            $dou->query("UPDATE " . $dou->table('coupon_log') . " SET use_time = '$add_time', order_sn = '$order_sn', status = '1' WHERE coupon_id = '$coupon_id' AND user_id = '$_GLOBAL_USER[user_id]'");
        }
    }
    
    // 配送方式信息
    $shipping = $dou->get_plugin($shipping_id);
    $shipping_fee = $shipping['config']['fee'];

    // 免费额度
    if (($shipping['config']['free'] && $item_amount >= $shipping['config']['free']) || $mode == 'point' || $module != 'product') 
        $shipping_fee = 0;

    // 计算运费和订单总额
    $order_amount = $item_amount + $shipping_fee;
    
    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);

    // 分销
    if ($_OPEN['distribution']) {
        include_once (ROOT_PATH . 'include/distribution.class.php');
        $dou_distribution = new Distribution();
     
        $direct_reward = $dou_distribution->reward_percent('direct', $user['direct_user_id']);
        $indirect_reward = $dou_distribution->reward_percent('indirect', $user['indirect_user_id']);
    }
    
    // 订单信息插入
    $dou->query("INSERT INTO " . $dou->table('order') . " (order_id, order_sn, user_id, direct_user_id, indirect_user_id, mode, module, contact_id, phone, contact, address, postcode, shipping_id, item_amount, shipping_fee, coupon_id, coupon_amount, order_amount, order_point, direct_reward, indirect_reward, item_link_status, add_time)" . " VALUES (NULL, '$order_sn', '$_GLOBAL_USER[user_id]', '$user[direct_user_id]', '$user[indirect_user_id]', '$mode', '$module', '$contact_id', '$phone', '$contact', '$address', '$_POST[postcode]', '$shipping_id', '$item_amount', '$shipping_fee', '$coupon_id', '$coupon_amount', '$order_amount', '$order_point', '$direct_reward', '$indirect_reward', '$item_link_status', '$add_time')");
 
    // 订单商品插入
    $order_id = $dou->insert_id();
    $stock_lock = $_CFG['stock'] && $dou->value_exist('plugin', 'plugin_group', 'payment') ? 1 : 0; // 开启库存功能并且有开启在线支付时才会将库存锁定
    foreach ($cart['list'] as $item) {
        if ($module == 'product')
            $cat_id = $dou->get_value($module, 'cat_id', "id = '$item[id]'");
     
        // 销售价格
        $sale_price = $item['sale_price'];
        
        $dou->query("INSERT INTO " . $dou->table('order_item') . " (id, user_id, direct_user_id, indirect_user_id, order_id, module, cat_id, item_id, name, price, sale_price, sale_price_type, point, direct_reward, indirect_reward, item_number, attribute, attribute_name, stock_lock, defined, add_time)" . " VALUES (NULL, '$_GLOBAL_USER[user_id]', '$user[direct_user_id]', '$user[indirect_user_id]', '$order_id', '$module', '$cat_id', '$item[item_id]', '$item[name]', '$item[price_normal]', '$sale_price[value]', '$sale_price[type]', '$item[point]', '$direct_reward', '$indirect_reward', '$item[number]', '$item[attribute]', '$item[attribute_name]', '$stock_lock', '$item[defined]', '$add_time')");
    }

    if ($_POST['update_user_information']) {
        // 判断是中文还是英文联系人信息
        $field_sql = $_CFG['language'] == 'en_us' ? ", first_name = '$_POST[first_name]', last_name = '$_POST[last_name]', country = '$_POST[country]', province = '$_POST[province]'" : ", contact = '$_POST[contact]'";
     
        $dou->query("UPDATE " . $dou->table('user') . " SET phone = '$_POST[phone]'" . $field_sql . ", address = '$_POST[address]', postcode = '$_POST[postcode]' WHERE user_id = '$_GLOBAL_USER[user_id]'");
    }
    
    // 显示订单信息
    $order['order_sn'] = $order_sn;
    $order['order_amount'] = $order_amount;
    $order['order_amount_format'] = $dou->price_format($order_amount);
    $order['order_point'] = $order_point;
    $order['mode'] = $mode;

    // 订单完成，清空购物车
    $dou_order->clear_cart();
 
    // 跳转到收银台
    if ($mode == 'money') {
        $cashier_url = $dou->param($_URL['cashier'] . '&order_sn=' . $order['order_sn']);
        $dou->dou_header($cashier_url);
    }

    $smarty->assign('page_title', $dou->page_title('order_success'));
    $smarty->assign('order', $order);
    
    $smarty->display('order.dwt');
}

/**
 * +----------------------------------------------------------
 * 更改运费和订单总额
 * +----------------------------------------------------------
 */
elseif ($rec == 'change_shipping') {
    $unique_id = preg_match("/^[A-Za-z0-9_-]+$/", $_REQUEST['unique_id']) ? $_REQUEST['unique_id'] : '';
    $shipping = $dou->get_one("SELECT config FROM " . $dou->table('plugin') . " WHERE unique_id = '$unique_id'");
    $shipping = unserialize($shipping);
    
    // 获取购物车信息
    $cart = $dou_order->get_cart();
    
    // 免费额度
    if ($shipping['free'] && $cart['item_amount'] >= $shipping['free']) $shipping['fee'] = 0;

    $_SESSION[DOU_ID]['fee'] = $shipping['fee'];
    
    $order = array (
            "shipping_fee" => $dou->price_format($shipping['fee']),
            "order_amount" => $dou->price_format($cart['item_amount'] + $shipping['fee'] - $_SESSION[DOU_ID]['coupon'])
    );
    
    echo json_encode($order);
}

/**
 * +----------------------------------------------------------
 * 使用优惠券
 * +----------------------------------------------------------
 */
elseif ($rec == 'use_coupon') {
    $coupon_id = $check->is_number($_POST['coupon_id']) ? $_POST['coupon_id'] : 0;
    
    // 获取购物车信息
    $cart = $dou_order->get_cart();
    
    // 免费额度
    $coupon = $dou_coupon->discount($coupon_id, $cart['item_amount']);
    if ($coupon) {
        $item_amount = $coupon['item_amount'];
        $coupon_amount = $coupon['amount'];
 
        $_SESSION[DOU_ID]['coupon'] = $coupon['amount'];
    } else {
        $item_amount = $cart['item_amount'];
        $coupon_amount = 0.00;
 
        $_SESSION[DOU_ID]['coupon'] = 0;
    }

    $order = array (
            "coupon_amount" => $dou->price_format($coupon_amount),
            "order_amount" => $dou->price_format($item_amount + $_SESSION[DOU_ID]['fee'])
    );
    
    echo json_encode($order);
}

/**
 * +----------------------------------------------------------
 * 收银台，必须要设置了支付方式才会跳转到该页面
 * +----------------------------------------------------------
 */
elseif ($rec == 'cashier') {
    // 验证是否登录
    if (!is_array($_GLOBAL_USER))
        $dou->dou_header($_URL['login']);

    // 获取订单信息
    $order_sn = $check->is_number($_REQUEST['order_sn']) ? $_REQUEST['order_sn'] : '';
    $order = $dou->get_row('order', '*', "order_sn = '$order_sn' AND status = '0' AND user_id = '$_GLOBAL_USER[user_id]'");
    if (!$order) {
        $dou->dou_header($_URL['user']);
    } else {
        $order['pay_url'] = $dou->param($_URL['pay'] . '&order_sn=' . $order['order_sn']);
        $order['order_amount_format'] = $dou->price_format($order['order_amount']);
        $order['pay_time_limit'] = $dou_order->pay_time_limit(); // 付款超时时间
    }
 
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('order_cashier'));
    $smarty->assign('head', $_LANG['order_cashier']);
    $smarty->assign('order', $order);
    $smarty->assign('payment_list', $dou_order->get_payment_list());
    
    $smarty->display('order.dwt');
}

/**
 * +----------------------------------------------------------
 * 收银台 支付
 * +----------------------------------------------------------
 */
elseif ($rec == 'pay') {
    // 验证是否登录
    if (!is_array($_GLOBAL_USER))
        $dou->dou_header($_URL['login']);

    // 获取订单信息
    $order_sn = $check->is_number($_REQUEST['order_sn']) ? $_REQUEST['order_sn'] : '';
    $order = $dou->get_row('order', '*', "order_sn = '$order_sn' AND status = '0' AND user_id = '$_GLOBAL_USER[user_id]'");
    if (!$order) {
        $dou->dou_header($_URL['user']);
    } else {
        $order['order_amount_format'] = $dou->price_format($order['order_amount']);
        $order['cashier_url'] = $dou->param($_URL['cashier'] . '&order_sn=' . $order['order_sn']);
        $order['pay_time_limit'] = $dou_order->pay_time_limit(); // 付款超时时间
    }
    
    // 生成支付操作
    $pay_id = preg_match("/^[a-z_-]+$/", $_REQUEST['pay_id']) ? $_REQUEST['pay_id'] : 0;
    $pay_name = $dou->get_one("SELECT name FROM " . $dou->table('plugin') . " WHERE unique_id = '$pay_id'");
    if ($pay_name) {
        include_once (ROOT_PATH . 'include/plugin/' . $pay_id . '/work.plugin.php');
        $plugin = new Plugin($order['order_sn'], $order['order_amount']);
        
        // 生成支付按钮
        $smarty->assign('payment', $plugin->work());
    } else {
        $dou->dou_header($order['cashier_url']);
    }
 
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('page', '', $pay_name));
    $smarty->assign('head', $pay_name);
    $smarty->assign('order', $order);
    
    $smarty->display('order.dwt');
}

/**
 * +----------------------------------------------------------
 * 收银台 上传付款凭证
 * +----------------------------------------------------------
 */
elseif ($rec == 'pay_evidence') {
    // 图片上传
    include_once (ROOT_PATH . 'include/file.class.php');
    $file = new File('images/pay/'); // 实例化类文件(文件上传路径，结尾加斜杠)
    
    // 验证是否登录
    if (!is_array($_GLOBAL_USER))
        $dou->dou_header($_URL['login']);

    // 订单权限验证
    $order_sn = $check->is_number($_POST['order_sn']) ? $_POST['order_sn'] : '';
    $order = $dou->get_row('order', '*', "order_sn = '$order_sn' AND user_id = '$_GLOBAL_USER[user_id]'");
    if (!$order) $dou->dou_header($_URL['order_list']);
    
    // 文件上传盒子
    if ($_FILES['pay_evidence']['name'] != "") {
        $pay_evidence = $file->box('order', $order_sn, 'pay_evidence', 'main', '', '', '', 800);
        $pay_evidence = $pay_evidence ? ", pay_evidence = '" . $pay_evidence . "'" : '';
    } else {
        $dou->dou_msg($_LANG['order_pay_evidence_cue']);
    }
    
    $pay_time = time();
    $sql = "UPDATE " . $dou->table('order') . " SET pay_id = 'offlinepay'" . $pay_evidence . ",pay_time = '$pay_time' , status = '-2' WHERE order_sn = '$order_sn' AND user_id = '$_GLOBAL_USER[user_id]'";
    $dou->query($sql);

    $dou->dou_header($_URL['order_list']);
}

/**
 * +----------------------------------------------------------
 * 收银台 货到付款
 * +----------------------------------------------------------
 */
elseif ($rec == 'cod') {
    if (!is_array($_GLOBAL_USER))
        $dou->dou_header($_URL['login']);

    // 订单权限验证
    $order_sn = $check->is_number($_POST['order_sn']) ? $_POST['order_sn'] : '';
    $order = $dou->get_row('order', '*', "order_sn = '$order_sn' AND user_id = '$_GLOBAL_USER[user_id]'");
    if (!$order) $dou->dou_header($_URL['order_list']);
 
    // 如果没有安装物流插件则直接将订单标记为已完成
    $status = $dou->value_exist('plugin', 'plugin_group', 'shipping') ? 1 : 10;
    
    $pay_time = time();
    $sql = "UPDATE " . $dou->table('order') . " SET pay_id = 'cod', pay_time = '$pay_time' , status = '$status' WHERE order_sn = '$order_sn' AND user_id = '$_GLOBAL_USER[user_id]'";
    $dou->query($sql);

    $dou->dou_header($_URL['order_list']);
}

?>