/**
 +----------------------------------------------------------
 * 监听
 +----------------------------------------------------------
 */
$(function() {
    $(".cartBox .minus").click(function() {
        var id = $(this).data("id");
        changeNumber(id, 'minus');
    });
 
    $(".cartBox .plus").click(function() {
        var id = $(this).data("id");
        changeNumber(id, 'plus');
    });
 
    $(".cartBox .inp").change(function() {
        var id = $(this).data("id");
        var number = $(this).val();
        changePrice(id, number);
    });
});

/**
 +----------------------------------------------------------
 * 更新购物车数量
 +----------------------------------------------------------
 */
function changeNumber(id, calculate) {
    var item = document.getElementById("number_" + id);
   
    if (calculate == 'plus') {
        item.value++;
    } else {
        if (item.value > 1) {
            item.value--;
        }
    }
    
    changePrice(id, item.value);
}

/**
 +----------------------------------------------------------
 * 更新购物车价格
 +----------------------------------------------------------
 */
function changePrice(id, number) {
    if (number == 0) {
        document.getElementById("number_" + id).value = 1;
        var number = 1;
    }
 
    $.ajax({
        type: "POST",
        url: root_url + 'order.php?rec=update',
        data: {"id":id, "number":number},
        dataType: "json",
        success: function(order) {
            $("#number_" + id).val(order.item_number);
            $("#subtotal_" + id).html(order.subtotal);
            $("#total").html(order.total);
            $("#item_amount").html(order.item_amount);
        }
    });
}

/**
 +----------------------------------------------------------
 * 更新快递费
 +----------------------------------------------------------
 */
function changeShipping(unique_id) {
    $.ajax({
        type: "POST",
        url: root_url + 'order.php?rec=change_shipping',
        data: {"unique_id":unique_id},
        dataType: "json",
        success: function(order) {
            $("#shipping_fee").html(order.shipping_fee);
            $(".order_amount").html(order.order_amount)
        }
    });
}

/**
 +----------------------------------------------------------
 * 使用优惠券
 +----------------------------------------------------------
 */
function useCoupon(coupon_id) {
    $.ajax({
        type: "POST",
        url: root_url + 'order.php?rec=use_coupon',
        data: {"coupon_id":coupon_id},
        dataType: "json",
        success: function(order) {
            console.log(order)
            $("#coupon_amount").html(order.coupon_amount);
            $(".order_amount").html(order.order_amount)
        }
    });
}

/**
 +----------------------------------------------------------
 * 联系人选择
 +----------------------------------------------------------
 */
if ($(".contact-box").length > 0) {
    var vm = new Vue({
        el:'.checkout',
        data:{
            contact:'',
            contact_info:[],
            contact_list:[],
            isVisible: false, // 初始状态为显示
            actionType:'list',
            formAction:'insert',
            formData: {name: '', telphone: '', province: '', city: '', district: '', address: '', tag: '', default: '', token: ''},
         
            /* ----------- 地区选择器 start ------------ */
            province_list: [],        // 省数据
            city_list: [],          // 市数据
            district_list: [],       // 区数据
            selectedProvince: null,
            selectedCity: null,
            selectedDistrict: null,
            /* ----------- 地区选择器 end ------------ */
            
            wrong:''
        },
    
        computed: {
            /* ----------- 地区选择器 start ------------ */
            // 控制区下拉框显示条件
            showDistrictSelect() {
              return this.district_list.length > 0;
            }
            /* ----------- 地区选择器 end ------------ */
        },

        mounted: function () {
            this.contactSelect();
            this.contactList();
        },

        methods:{
            // 联系人列表
            contactList:function() {
                this.$http.post(root_url + 'user.php?rec=contact&act=list',{contact_id:this.contact.id},{emulateJSON:true}).then(function(res){
                    if (res.data.wrong) {
                        alert(res.data.wrong);
                    }
                    
                    if (res.data.contact_list) {
                        this.contact_list = res.data.contact_list;
                    }
                },function(res){
                    console.log('失败')
                })
            },

            // 选择联系人
            contactSelect:function(contact_id, actionPuput = true) {
                this.$http.post(root_url + 'user.php?rec=contact&act=info',{contact_id:contact_id},{emulateJSON:true}).then(function(res){
                    if (res.data.wrong) {
                        alert(res.data.wrong);
                    }

                    if (res.data.contact) {
                        this.contact = res.data.contact;
                        this.contactList();
                        if (contact_id && actionPuput) {
                            this.contactPopup(); // 关闭弹出窗口
                        }
                    }
                },function(res){
                    console.log('失败')
                })
            },

            // 联系人详情
            contactInfo:function(contact_id) {
                this.$http.post(root_url + 'user.php?rec=contact&act=info',{contact_id:contact_id},{emulateJSON:true}).then(function(res){
                    if (res.data.wrong) {
                        alert(res.data.wrong);
                    }
                    
                    this.formData.id = contact_id;
                    this.formData = res.data.contact;
                },function(res){
                    console.log('失败')
                })
            },

            // 联系人操作框
            contactPopup:function(type, contact_id) {
                this.isVisible = !this.isVisible; // 切换状态
                this.actionType = type;
             
                if (type == 'add' || type == 'edit') {
                    if (contact_id) {
                        console.log(contact_id)
                        this.contactInfo(contact_id);
                        this.area_init(contact_id);
                    } else {
                        this.formData = {name: '', telphone: '', province: '', city: '', district: '', address: '', tag: '', default: '', token: ''};
                        this.provinceList();
                        this.city_list = [];
                        this.district_list = [];
                    }
                 
                    this.formAction = type == 'add' ? 'insert' : 'update';
                }
            },
         
            // 添加或编辑
            contactForm() {
                this.formData.token = this.$refs.token.value;
                this.$http.post(root_url + 'user.php?rec=contact&act=' + this.formAction + '&do=vue', this.formData, {
                    headers: {
                      'Content-Type': 'application/x-www-form-urlencoded'
                    },
                    emulateJSON: true  // 对于 vue-resource 可能需要这个选项
                }).then(res => {
                    if (res.data.wrong) {
                        alert(res.data.wrong);
                    } else {
                        this.contact_id = res.data.contact_id;
                        this.contactSelect(res.data.contact_id, false);
                        this.contactList();
                        this.isVisible = false;
                    }
                })
                .catch(error => {
                    // 请求失败处理
                    console.error('提交失败', error)
                })
            },
         
            /* ----------- 地区选择器 start ------------ */
            // 初始化
            area_init:function(contact_id) {
                this.$http.post(root_url + 'user.php?rec=area',{type:'init', id:contact_id},{emulateJSON:true}).then(function(res){
                    if (res.data.wrong) {
                        alert(res.data.wrong);
                    }

                    if (res.data.contact) {
                        this.formData.province = res.data.contact.selectedProvince;
                        this.provinceList();

                        if (res.data.contact.selectedCity) {
                            this.formData.city = res.data.contact.selectedCity;
                            this.cityList();
                        }

                        if (res.data.contact.selectedDistrict) {
                            this.formData.district = res.data.contact.selectedDistrict;
                            this.districtList();
                        }
                    }
                },function(res){
                    console.log(res.data)
                })
            },

            // 省份列表
            provinceList:function() {
                this.$http.post(root_url + 'user.php?rec=area',{type:'province', current:this.formData.province},{emulateJSON:true}).then(function(res){
                    if (res.data.wrong) {
                        alert(res.data.wrong);
                    }

                    if (res.data.area_list) {
                        this.province_list = res.data.area_list;
                    }
                },function(res){
                    console.log(res.data)
                })
            },

            // 城市列表
            cityList:function() {
                this.$http.post(root_url + 'user.php?rec=area',{type:'city', parent:this.formData.province, current:this.formData.city},{emulateJSON:true}).then(function(res){
                    if (res.data.wrong) {
                        alert(res.data.wrong);
                    }

                    if (res.data.area_list) {
                        this.city_list = res.data.area_list;
                    }
                },function(res){
                    console.log(res.data)
                })
            },

            // 获取区县数据
            districtList() {
                this.$http.post(root_url + 'user.php?rec=area',{type:'district', parent:this.formData.city, current:this.formData.district},{emulateJSON:true}).then(function(res){
                    if (res.data.wrong) {
                        alert(res.data.wrong);
                    }
                    
                    if (res.data.area_list) {
                        this.district_list = res.data.area_list;
                    }
                },function(res){
                    console.log(res.data)
                })
            },

            // 省份选择变化处理
            handleProvinceChange() {
                this.formData.city = null;
                this.formData.district = null;
                this.district_list = [];

                if (this.formData.province) {
                    this.cityList();
                } else {
                    this.city_list = [];
                }
            },

            // 城市选择变化处理
            handleCityChange() {
                this.formData.district = null;
                if (this.formData.city) {
                    this.districtList();
                } else {
                    this.district_list = [];
                }
            },
            /* ----------- 地区选择器 end ------------ */
        },
    })
}